#include <gtk/gtk.h>
#include <libxfcegui4/libxfcegui4.h>

void show_fileops(GtkWidget * widget, GtkFileSelection * fs)
{
    gboolean show_ops;

    show_ops = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget));

    if(show_ops)
        gtk_file_selection_show_fileop_buttons(fs);
    else
        gtk_file_selection_hide_fileop_buttons(fs);
}

void select_multiple(GtkWidget * widget, GtkFileSelection * fs)
{
    gboolean select_multiple;

    select_multiple = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget));
    gtk_file_selection_set_select_multiple(fs, select_multiple);
}

void file_selection_ok(GtkFileSelection * fs)
{
    int i;
    gchar **selections;

    selections = gtk_file_selection_get_selections(fs);

    for(i = 0; selections[i] != NULL; i++)
        g_print("%s\n", selections[i]);

    g_strfreev(selections);

    gtk_widget_destroy(GTK_WIDGET(fs));
    
    gtk_main_quit();
}

int main(int argc, char *argv[])
{
    static GtkWidget *window = NULL;
    GtkWidget *button;

    gtk_init(&argc, &argv);

    window = preview_file_selection_new("file selection dialog", TRUE);

    gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION(window));

    gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_MOUSE);

    g_signal_connect(window, "destroy", G_CALLBACK(gtk_widget_destroyed), &window);

    g_signal_connect_swapped(GTK_FILE_SELECTION(window)->ok_button, "clicked", G_CALLBACK(file_selection_ok), window);
    g_signal_connect_swapped(GTK_FILE_SELECTION(window)->cancel_button, "clicked", G_CALLBACK(gtk_widget_destroy), window);

    button = gtk_check_button_new_with_label("Show Fileops");
    g_signal_connect(button, "toggled", G_CALLBACK(show_fileops), window);
    gtk_box_pack_start(GTK_BOX(GTK_FILE_SELECTION(window)->action_area), button, FALSE, FALSE, 0);
    gtk_widget_show(button);

    button = gtk_check_button_new_with_label("Select Multiple");
    g_signal_connect(button, "clicked", G_CALLBACK(select_multiple), window);
    gtk_box_pack_start(GTK_BOX(GTK_FILE_SELECTION(window)->action_area), button, FALSE, FALSE, 0);

    gtk_widget_show(button);

    gtk_widget_show(window);

    gtk_main();

    return 0;
}
